package eu.ztsh.garmin.data

import com.mapbox.navigation.core.trip.session.LocationMatcherResult
import com.mapbox.navigation.core.trip.session.NavigationSessionState
import com.mapbox.navigation.tripdata.maneuver.model.Maneuver

class DataCache {

    private val garminManeuver: GarminManeuver = GarminManeuver.empty()
    private var maneuverCache: Maneuver? = null
    private var locationCache: LocationMatcherResult? = null
    private var session: NavigationSessionState? = null

    // state
    fun hasChanged(lanes: Lanes): Boolean {
        return garminManeuver.lanes != lanes
    }

    fun hasChanged(distance: Distance): Boolean {
        return garminManeuver.distance != distance
    }

    fun hasChanged(direction: Direction): Boolean {
        return garminManeuver.direction != direction
    }
//
//    fun hasChanged(speed: Speed?): Boolean {
//        return stateCache.speed == null || stateCache.speed != speed
//    }
//
//    fun hasChanged(arrival: Arrival?): Boolean {
//        return stateCache.arrival == null || stateCache.arrival != arrival
//    }

    // Merge states
    fun update(item: GarminModelItem) {
        when(item) {
            is GarminManeuver -> garminManeuver.merge(item)
        }

    }

    // maneuver
    fun hasChanged(maneuver: Maneuver): Boolean {
        return maneuverCache == null || maneuverCache!! != maneuver
    }

    fun update(maneuver: Maneuver) {
        maneuverCache = maneuver
    }

    // location
    fun hasChanged(locationMatcherResult: LocationMatcherResult): Boolean {
        return locationCache == null || locationCache!! != locationMatcherResult
    }

    fun update(locationMatcherResult: LocationMatcherResult) {
        locationCache = locationMatcherResult
    }

    // session
    fun isActive(): Boolean {
        return session != null && session is NavigationSessionState.ActiveGuidance
    }

    fun update(sessionState: NavigationSessionState) {
        session = sessionState
    }

}