package eu.ztsh.garmin.data

import com.mapbox.navigation.tripdata.maneuver.model.Maneuver
import com.mapbox.navigation.core.trip.session.LocationMatcherResult

class MapboxMapper {

    companion object {

        fun map(maneuver: Maneuver): GarminManeuver {
            val state = GarminManeuver()
            maneuver.apply {
                this.primary.apply {
                    state.direction = Direction()
                    when (this.type) {
                        "roundabout" -> {
                            state.direction.out = OutType.RightRoundabout
                        }

                        "arrive" -> {
                            state.flag = true
                        }
                    }
                    when (this.modifier) {
                        "right" -> {
                            when (this.type) {
                                "turn" -> state.direction.angle = OutAngle.Right
                                "roundabout" -> {
                                    when (this.degrees) {
                                        137.0 -> state.direction.angle = OutAngle.EasyRight
                                        180.0 -> state.direction.angle = OutAngle.Straight
                                    }
                                }
                            }
                        }

                        "left" -> {
                            when (this.type) {
                                "turn" -> state.direction.angle = OutAngle.Left
                            }
                        }
                    }
                }
                this.stepDistance.apply {
                    this.distanceRemaining?.apply {
                        distanceFormatter.formatDistance(this).split(" ").apply {
                            state.distance = Distance(
                                this[0].replace(',', '.').toDouble(),
                                when (this[1]) {
                                    "m" -> Unit.Metres
                                    "km" -> Unit.Kilometres
                                    else -> Unit.Any
                                }
                            )

                        }
                    }
                }
                // TODO: implement
                state.lanes = Lanes(Arrows(listOf()), Arrows(listOf()))
                this.laneGuidance?.apply {
                    this.allLanes.apply {
                        println()
                    }
                }
            }
            return state
        }

        fun map(locationMatcherResult: LocationMatcherResult): GarminLocation {
            val state = GarminLocation()
            // TODO: speed, limit, location?, bearing
            return state
        }

    }

}
